diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index f80f10dca84..6d1761ca005 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -1262,24 +1194,24 @@ program_state::detect_leaks2 (const program_state &src_state,
     }
 
   /* Get svalues reachable from each of src_state and dst_state.  */
-  svalue2_set src_svalues;
-  svalue2_set dest_svalues;
-  src_state.m_region_model2->get_reachable_svalues (&src_svalues, NULL);
-  dest_state.m_region_model2->get_reachable_svalues (&dest_svalues,
+  svalue_set src_svalues;
+  svalue_set dest_svalues;
+  src_state.m_region_model->get_reachable_svalues (&src_svalues, NULL);
+  dest_state.m_region_model->get_reachable_svalues (&dest_svalues,
 						     extra_sval);
 
   if (logger)
     {
-      log_set_of_svalue2s (logger, "src_state reachable svalues:", src_svalues);
-      log_set_of_svalue2s (logger, "dest_state reachable svalues:",
+      log_set_of_svalues (logger, "src_state reachable svalues:", src_svalues);
+      log_set_of_svalues (logger, "dest_state reachable svalues:",
 			   dest_svalues);
     }
 
-  for (svalue2_set::iterator iter = src_svalues.begin ();
+  for (svalue_set::iterator iter = src_svalues.begin ();
        iter != src_svalues.end (); ++iter)
     {
-      const svalue2 *sval = (*iter);
-      if (!sval->live_p (dest_svalues, dest_state.m_region_model2))
+      const svalue *sval = (*iter);
+      if (!sval->live_p (dest_svalues, dest_state.m_region_model))
 	{
 #if 0
 	  pretty_printer pp1, pp2, pp3;
@@ -1294,188 +1226,19 @@ program_state::detect_leaks2 (const program_state &src_state,
 		 pp_formatted_text (&pp2),
 		 pp_formatted_text (&pp3));
 #endif
-	  ctxt->on_svalue2_leak (sval);
+	  ctxt->on_svalue_leak (sval);
 
 	}
     }
 
   /* Purge dead svals from sm-state.  */
-  ctxt->on_liveness_change (dest_svalues, dest_state.m_region_model2);
+  ctxt->on_liveness_change (dest_svalues, dest_state.m_region_model);
 
   /* Purge dead svals from constraints.  */
-  dest_state.m_region_model2->get_constraints2 ()->on_liveness_change
-    (dest_svalues, dest_state.m_region_model2);
-}
-
-#if 0
-/* Dump this sm_change to PP.  */
-
-void
-state_change::sm_change::dump (pretty_printer *pp,
-			       const extrinsic_state &ext_state) const
-{
-  const state_machine &sm = get_sm (ext_state);
-  pp_string (pp, "(");
-  m_new_sid.print (pp);
-  pp_printf (pp, ": %s: %qs -> %qs)",
-	     sm.get_name (),
-	     sm.get_state_name (m_old_state),
-	     sm.get_state_name (m_new_state));
-}
-
-/* Remap all svalue_ids in this change according to MAP.  */
-
-void
-state_change::sm_change::remap_svalue_ids (const svalue_id_map &map)
-{
-  map.update (&m_new_sid);
-}
-
-/* Purge any svalue_ids >= FIRST_UNUSED_SID.
-   Return the number of states that were purged.  */
-
-int
-state_change::sm_change::on_svalue_purge (svalue_id first_unused_sid)
-{
-  if (m_new_sid.as_int () >= first_unused_sid.as_int ())
-    {
-      m_new_sid = svalue_id::null ();
-      return 1;
-    }
-
-  return 0;
-}
-
-/* Assert that this object is sane.  */
-
-void
-state_change::sm_change::validate (const program_state &new_state,
-				   const extrinsic_state &ext_state) const
-{
-  gcc_assert ((unsigned)m_sm_idx < ext_state.get_num_checkers ());
-  const state_machine &sm = ext_state.get_sm (m_sm_idx);
-  sm.validate (m_old_state);
-  sm.validate (m_new_state);
-  m_new_sid.validate (*new_state.m_region_model);
-}
-
-/* state_change's ctor.  */
-
-state_change::state_change ()
-{
-}
-
-/* state_change's copy ctor.  */
-
-state_change::state_change (const state_change &other)
-: m_sm_changes (other.m_sm_changes.length ())
-{
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (other.m_sm_changes, i, change)
-    m_sm_changes.quick_push (*change);
-}
-
-/* Record a state-machine state change.  */
-
-void
-state_change::add_sm_change (int sm_idx,
-			     svalue_id new_sid,
-			     state_machine::state_t old_state,
-			     state_machine::state_t new_state)
-{
-  m_sm_changes.safe_push (sm_change (sm_idx,
-				     new_sid,
-				     old_state, new_state));
-}
-
-/* Return true if SID (in the new state) was affected by any
-   sm-state changes.  */
-
-bool
-state_change::affects_p (svalue_id sid) const
-{
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (m_sm_changes, i, change)
-    {
-      if (sid == change->m_new_sid)
-	return true;
-    }
-  return false;
-}
-
-/* Dump this state_change to PP.  */
-
-void
-state_change::dump (pretty_printer *pp,
-		    const extrinsic_state &ext_state) const
-{
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (m_sm_changes, i, change)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      change->dump (pp, ext_state);
-    }
-}
-
-/* Dump this state_change to stderr.  */
-
-void
-state_change::dump (const extrinsic_state &ext_state) const
-{
-  pretty_printer pp;
-  pp_show_color (&pp) = pp_show_color (global_dc->printer);
-  pp.buffer->stream = stderr;
-  dump (&pp, ext_state);
-  pp_newline (&pp);
-  pp_flush (&pp);
-}
-
-/* Remap all svalue_ids in this state_change according to MAP.  */
-
-void
-state_change::remap_svalue_ids (const svalue_id_map &map)
-{
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (m_sm_changes, i, change)
-    change->remap_svalue_ids (map);
-}
-
-/* Purge any svalue_ids >= FIRST_UNUSED_SID.
-   Return the number of states that were purged.  */
-
-int
-state_change::on_svalue_purge (svalue_id first_unused_sid)
-{
-  int result = 0;
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (m_sm_changes, i, change)
-    result += change->on_svalue_purge (first_unused_sid);
-  return result;
+  dest_state.m_region_model->get_constraints ()->on_liveness_change
+    (dest_svalues, dest_state.m_region_model);
 }
 
-/* Assert that this object is sane.  */
-
-void
-state_change::validate (const program_state &new_state,
-			const extrinsic_state &ext_state) const
-{
-  /* Skip this in a release build.  */
-#if !CHECKING_P
-  return;
-#endif
-  unsigned i;
-  sm_change *change;
-  FOR_EACH_VEC_ELT (m_sm_changes, i, change)
-    change->validate (new_state, ext_state);
-}
-#endif
-
 #if CHECKING_P
 
 namespace selftest {
@@ -1513,133 +1276,6 @@ test_sm_state_map ()
   tree y = build_global_decl ("y", integer_type_node);
   tree z = build_global_decl ("z", integer_type_node);
 
-  // TODO: coverage for purging
-}
-
-/* Verify that program_state::dump_to_pp works as expected.  */
-
-static void
-test_program_state_dumping ()
-{
-}
-
-/* Verify that program_state::dump_to_pp works for string literals.  */
-
-static void
-test_program_state_dumping_2 ()
-{
-}
-
-/* Verify that program_states with identical sm-state can be merged,
-   and that the merged program_state preserves the sm-state.  */
-
-static void
-test_program_state_merging ()
-{
-  program_point point (program_point::origin ());
-
-  /* Create a program_state for a global ptr "p" that has
-     malloc sm-state, pointing to a region on the heap.  */
-  tree p = build_global_decl ("p", ptr_type_node);
-
-  auto_delete_vec <state_machine> checkers;
-  checkers.safe_push (make_malloc_state_machine (NULL));
-  extrinsic_state ext_state (checkers);
-
-  program_state s0 (ext_state);
-#if 0
-  impl_region_model_context ctxt (&s0, NULL, ext_state);
-
-  region_model *model0 = s0.m_region_model;
-  region_id new_rid = model0->add_new_malloc_region ();
-  svalue_id ptr_sid
-      = model0->get_or_create_ptr_svalue (ptr_type_node, new_rid);
-  model0->set_value (model0->get_lvalue (p, &ctxt),
-		     ptr_sid, &ctxt);
-  sm_state_map *smap = s0.m_checker_states[0];
-  const state_machine::state_t TEST_STATE = 3;
-  smap->impl_set_state (ptr_sid, TEST_STATE, svalue_id::null ());
-  ASSERT_EQ (smap->get_state (ptr_sid), TEST_STATE);
-
-  model0->canonicalize (&ctxt);
-
-  /* Verify that canonicalization preserves sm-state.  */
-  ASSERT_EQ (smap->get_state (model0->get_rvalue (p, NULL)), TEST_STATE);
-
-  /* Make a copy of the program_state.  */
-  program_state s1 (s0);
-  ASSERT_EQ (s0, s1);
-
-  /* We have two identical states with "p" pointing to a heap region
-     with the given sm-state.
-     They ought to be mergeable, preserving the sm-state.  */
-  program_state merged (ext_state);
-  ASSERT_TRUE (s0.can_merge_with_p (s1, ext_state, point, &merged));
-  merged.validate (ext_state);
-
-  /* Verify that the merged state has the sm-state for "p".  */
-  region_model *merged_model = merged.m_region_model;
-  sm_state_map *merged_smap = merged.m_checker_states[0];
-  ASSERT_EQ (merged_smap->get_state (merged_model->get_rvalue (p, NULL)),
-	     TEST_STATE);
-
-  /* Try canonicalizing.  */
-  impl_region_model_context merged_ctxt (&merged, NULL, ext_state);
-  merged.m_region_model->canonicalize (&merged_ctxt);
-  merged.validate (ext_state);
-
-  /* Verify that the merged state still has the sm-state for "p".  */
-  ASSERT_EQ (merged_smap->get_state (merged_model->get_rvalue (p, NULL)),
-	     TEST_STATE);
-
-  /* After canonicalization, we ought to have equality with the inputs.  */
-  ASSERT_EQ (s0, merged);
-#endif
-}
-
-/* Verify that program_states with different global-state in an sm-state
-   can't be merged.  */
-
-static void
-test_program_state_merging_2 ()
-{
-  program_point point (program_point::origin ());
-  auto_delete_vec <state_machine> checkers;
-  checkers.safe_push (make_signal_state_machine (NULL));
-  extrinsic_state ext_state (checkers);
-
-  program_state s0 (ext_state);
-  {
-    sm_state_map2 *smap0 = s0.m_checker_states2[0];
-    const state_machine::state_t TEST_STATE_0 = 0;
-    smap0->set_global_state (TEST_STATE_0);
-    ASSERT_EQ (smap0->get_global_state (), TEST_STATE_0);
-  }
-
-  program_state s1 (ext_state);
-  {
-    sm_state_map2 *smap1 = s1.m_checker_states2[0];
-    const state_machine::state_t TEST_STATE_1 = 1;
-    smap1->set_global_state (TEST_STATE_1);
-    ASSERT_EQ (smap1->get_global_state (), TEST_STATE_1);
-  }
-
-  ASSERT_NE (s0, s1);
-
-  /* They ought to not be mergeable.  */
-  program_state merged (ext_state);
-  ASSERT_FALSE (s0.can_merge_with_p (s1, ext_state, point, &merged));
-}
-
-/* Tests for sm_state_map2.  */
-
-static void
-test_sm_state_map2 ()
-{
-  tree x = build_global_decl ("x", integer_type_node);
-  tree y = build_global_decl ("y", integer_type_node);
-  tree z = build_global_decl ("z", integer_type_node);
-
   state_machine *sm = make_malloc_state_machine (NULL);
   auto_delete_vec <state_machine> checkers;
   checkers.safe_push (sm);
@@ -1647,13 +1283,13 @@ test_sm_state_map2 ()
 
   /* Test setting states on svalue_id instances directly.  */
   {
-    region_model2_manager mgr;
-    region_model2 model (&mgr);
-    const svalue2 *x_sval = model.get_rvalue (x, NULL);
-    const svalue2 *y_sval = model.get_rvalue (y, NULL);
-    const svalue2 *z_sval = model.get_rvalue (z, NULL);
+    region_model_manager mgr;
+    region_model model (&mgr);
+    const svalue *x_sval = model.get_rvalue (x, NULL);
+    const svalue *y_sval = model.get_rvalue (y, NULL);
+    const svalue *z_sval = model.get_rvalue (z, NULL);
 
-    sm_state_map2 map (*sm, 0);
+    sm_state_map map (*sm, 0);
     ASSERT_TRUE (map.is_empty_p ());
     ASSERT_EQ (map.get_state (x_sval, ext_state), 0);
 
@@ -1673,13 +1309,13 @@ test_sm_state_map2 ()
 
   /* Test setting states via equivalence classes.  */
   {
-    region_model2_manager mgr;
-    region_model2 model (&mgr);
-    const svalue2 *x_sval = model.get_rvalue (x, NULL);
-    const svalue2 *y_sval = model.get_rvalue (y, NULL);
-    const svalue2 *z_sval = model.get_rvalue (z, NULL);
+    region_model_manager mgr;
+    region_model model (&mgr);
+    const svalue *x_sval = model.get_rvalue (x, NULL);
+    const svalue *y_sval = model.get_rvalue (y, NULL);
+    const svalue *z_sval = model.get_rvalue (z, NULL);
 
-    sm_state_map2 map (*sm, 0);
+    sm_state_map map (*sm, 0);
     ASSERT_TRUE (map.is_empty_p ());
     ASSERT_EQ (map.get_state (x_sval, ext_state), 0);
     ASSERT_EQ (map.get_state (y_sval, ext_state), 0);
@@ -1697,14 +1333,14 @@ test_sm_state_map2 ()
 
   /* Test equality and hashing.  */
   {
-    region_model2_manager mgr;
-    region_model2 model (&mgr);
-    const svalue2 *y_sval = model.get_rvalue (y, NULL);
-    const svalue2 *z_sval = model.get_rvalue (z, NULL);
+    region_model_manager mgr;
+    region_model model (&mgr);
+    const svalue *y_sval = model.get_rvalue (y, NULL);
+    const svalue *z_sval = model.get_rvalue (z, NULL);
 
-    sm_state_map2 map0 (*sm, 0);
-    sm_state_map2 map1 (*sm, 0);
-    sm_state_map2 map2 (*sm, 0);
+    sm_state_map map0 (*sm, 0);
+    sm_state_map map1 (*sm, 0);
+    sm_state_map map2 (*sm, 0);
 
     ASSERT_EQ (map0.hash (), map1.hash ());
     ASSERT_EQ (map0, map1);
@@ -1721,18 +1357,18 @@ test_sm_state_map2 ()
 
   /* Equality and hashing shouldn't depend on ordering.  */
   {
-    sm_state_map2 map0 (*sm, 0);
-    sm_state_map2 map1 (*sm, 0);
-    sm_state_map2 map2 (*sm, 0);
+    sm_state_map map0 (*sm, 0);
+    sm_state_map map1 (*sm, 0);
+    sm_state_map map2 (*sm, 0);
 
     ASSERT_EQ (map0.hash (), map1.hash ());
     ASSERT_EQ (map0, map1);
 
-    region_model2_manager mgr;
-    region_model2 model (&mgr);
-    const svalue2 *x_sval = model.get_rvalue (x, NULL);
-    const svalue2 *y_sval = model.get_rvalue (y, NULL);
-    const svalue2 *z_sval = model.get_rvalue (z, NULL);
+    region_model_manager mgr;
+    region_model model (&mgr);
+    const svalue *x_sval = model.get_rvalue (x, NULL);
+    const svalue *y_sval = model.get_rvalue (y, NULL);
+    const svalue *z_sval = model.get_rvalue (z, NULL);
 
     map1.impl_set_state (x_sval, 2, NULL, ext_state);
     map1.impl_set_state (y_sval, 3, NULL, ext_state);
@@ -1752,7 +1388,7 @@ test_sm_state_map2 ()
 /* Verify that program_state::dump_to_pp works as expected.  */
 
 static void
-test_program_state2_dumping ()
+test_program_state_dumping ()
 {
 #if 0
   /* Create a program_state for a global ptr "p" that has
@@ -1767,13 +1403,13 @@ test_program_state2_dumping ()
   extrinsic_state ext_state (checkers);
 
   program_state s (ext_state);
-  region_model2 *model = s.m_region_model;
+  region_model *model = s.m_region_model;
   region_id new_rid = model->add_new_malloc_region ();
   svalue_id ptr_sid
       = model->get_or_create_ptr_svalue (ptr_type_node, new_rid);
   model->set_value (model->get_lvalue (p, NULL),
 		    ptr_sid, NULL);
-  sm_state_map2 *smap = s.m_checker_states2[0];
+  sm_state_map *smap = s.m_checker_states[0];
 
   smap->impl_set_state (ptr_sid, UNCHECKED_STATE, svalue_id::null ());
   ASSERT_EQ (smap->get_state (ptr_sid), UNCHECKED_STATE);
@@ -1783,28 +1419,28 @@ test_program_state2_dumping ()
      "rmodel: r0: {kind: `root', parent: null, sval: null}\n"
      "|-heap: r1: {kind: `heap', parent: r0, sval: sv0}\n"
      "|  |: sval: sv0: {poisoned: uninit}\n"
-     "|  `-r2: {kind: `symbolic', parent: r1, sval: null, possibly_null: true}\n"
+     "|  `-r: {kind: `symbolic', parent: r1, sval: null, possibly_null: true}\n"
      "`-globals: r3: {kind: `globals', parent: r0, sval: null, map: {`p': r4}}\n"
      "  `-`p': r4: {kind: `primitive', parent: r3, sval: sv1, type: `void *'}\n"
-     "    |: sval: sv1: {type: `void *', &r2}\n"
+     "    |: sval: sv1: {type: `void *', &r}\n"
      "    |: type: `void *'\n"
      "svalues:\n"
      "  sv0: {poisoned: uninit}\n"
-     "  sv1: {type: `void *', &r2}\n"
+     "  sv1: {type: `void *', &r}\n"
      "constraint manager:\n"
      "  equiv classes:\n"
      "  constraints:\n"
      "malloc: {sv1: unchecked (`p')}\n");
 
   ASSERT_DUMP_EQ (s, ext_state, true,
-		  "rmodel: p: &r2 malloc: {sv1: unchecked (`p')}");
+		  "rmodel: p: &r malloc: {sv1: unchecked (`p')}");
 #endif
 }
 
 /* Verify that program_state::dump_to_pp works for string literals.  */
 
 static void
-test_program_state2_dumping_2 ()
+test_program_state_dumping_2 ()
 {
 #if 0
   /* Create a program_state for a global ptr "p" that points to
@@ -1852,7 +1488,7 @@ test_program_state2_dumping_2 ()
    and that the merged program_state preserves the sm-state.  */
 
 static void
-test_program_state2_merging ()
+test_program_state_merging ()
 {
 #if 0
   /* Create a program_state for a global ptr "p" that has
@@ -1872,7 +1508,7 @@ test_program_state2_merging ()
       = model0->get_or_create_ptr_svalue (ptr_type_node, new_rid);
   model0->set_value (model0->get_lvalue (p, &ctxt),
 		     ptr_sid, &ctxt);
-  sm_state_map2 *smap = s0.m_checker_states[0];
+  sm_state_map *smap = s0.m_checker_states[0];
   const state_machine::state_t TEST_STATE = 3;
   smap->impl_set_state (ptr_sid, TEST_STATE, svalue_id::null ());
   ASSERT_EQ (smap->get_state (ptr_sid), TEST_STATE);
@@ -1895,7 +1531,7 @@ test_program_state2_merging ()
 
   /* Verify that the merged state has the sm-state for "p".  */
   region_model *merged_model = merged.m_region_model;
-  sm_state_map2 *merged_smap = merged.m_checker_states[0];
+  sm_state_map *merged_smap = merged.m_checker_states[0];
   ASSERT_EQ (merged_smap->get_state (merged_model->get_rvalue (p, NULL)),
 	     TEST_STATE);
 
@@ -1917,7 +1553,7 @@ test_program_state2_merging ()
    can't be merged.  */
 
 static void
-test_program_state2_merging_2 ()
+test_program_state_merging_2 ()
 {
 #if 0
   auto_delete_vec <state_machine> checkers;
@@ -1926,7 +1562,7 @@ test_program_state2_merging_2 ()
 
   program_state s0 (ext_state);
   {
-    sm_state_map2 *smap0 = s0.m_checker_states[0];
+    sm_state_map *smap0 = s0.m_checker_states[0];
     const state_machine::state_t TEST_STATE_0 = 0;
     smap0->set_global_state (TEST_STATE_0);
     ASSERT_EQ (smap0->get_global_state (), TEST_STATE_0);
@@ -1934,7 +1570,7 @@ test_program_state2_merging_2 ()
 
   program_state s1 (ext_state);
   {
-    sm_state_map2 *smap1 = s1.m_checker_states[0];
+    sm_state_map *smap1 = s1.m_checker_states[0];
     const state_machine::state_t TEST_STATE_1 = 1;
     smap1->set_global_state (TEST_STATE_1);
     ASSERT_EQ (smap1->get_global_state (), TEST_STATE_1);
@@ -1958,12 +1594,6 @@ analyzer_program_state_cc_tests ()
   test_program_state_dumping_2 ();
   test_program_state_merging ();
   test_program_state_merging_2 ();
-
-  test_sm_state_map2 ();
-  test_program_state2_dumping ();
-  test_program_state2_dumping_2 ();
-  test_program_state2_merging ();
-  test_program_state2_merging_2 ();
 }
 
 } // namespace selftest
diff --git a/gcc/analyzer/program-state.h b/gcc/analyzer/program-state.h
index 22b7a6bf297..6c3a7bf5af7 100644
--- a/gcc/analyzer/program-state.h
+++ b/gcc/analyzer/program-state.h
@@ -30,8 +30,8 @@ class extrinsic_state
 public:
   extrinsic_state (auto_delete_vec <state_machine> &checkers,
 		   logger *logger = NULL,
-		   engine2 *eng2 = NULL)
-  : m_checkers (checkers), m_logger (logger), m_engine2 (eng2)
+		   engine *eng = NULL)
+  : m_checkers (checkers), m_logger (logger), m_engine (eng)
   {
   }
 
@@ -53,21 +53,21 @@ public:
   void dump_to_file (FILE *outf) const;
   void dump () const;
 
-  engine2 *get_engine2 () const { return m_engine2; }
-  region_model2_manager *get_model_manager () const;
+  engine *get_engine () const { return m_engine; }
+  region_model_manager *get_model_manager () const;
 
 private:
   /* The state machines.  */
   auto_delete_vec <state_machine> &m_checkers;
 
   logger *m_logger;
-  engine2 *m_engine2;
+  engine *m_engine;
 };
 
-/* Map from svalue2 * to state machine state, also capturing the origin of
+/* Map from svalue * to state machine state, also capturing the origin of
    each state.  */
 
-class sm_state_map2
+class sm_state_map
 {
 public:
   /* An entry in the hash_map.  */
@@ -80,7 +80,7 @@ public:
     }
 
     entry_t (state_machine::state_t state,
-	     const svalue2 *origin)
+	     const svalue *origin)
     : m_state (state), m_origin (origin)
     {}
 
@@ -95,16 +95,16 @@ public:
     }
 
     state_machine::state_t m_state;
-    const svalue2 *m_origin;
+    const svalue *m_origin;
   };
-  typedef hash_map <const svalue2 *, entry_t> map_t;
+  typedef hash_map <const svalue *, entry_t> map_t;
   typedef map_t::iterator iterator_t;
 
-  sm_state_map2 (const state_machine &sm, int m_sm_idx);
+  sm_state_map (const state_machine &sm, int m_sm_idx);
 
-  sm_state_map2 *clone () const;
+  sm_state_map *clone () const;
 
-  void print (const region_model2 *model,
+  void print (const region_model *model,
 	      bool simple, bool multiline,
 	      pretty_printer *pp) const;
   void dump (bool simple) const;
@@ -113,29 +113,29 @@ public:
 
   hashval_t hash () const;
 
-  bool operator== (const sm_state_map2 &other) const;
-  bool operator!= (const sm_state_map2 &other) const
+  bool operator== (const sm_state_map &other) const;
+  bool operator!= (const sm_state_map &other) const
   {
     return !(*this == other);
   }
 
-  state_machine::state_t get_state (const svalue2 *sval,
+  state_machine::state_t get_state (const svalue *sval,
 				    const extrinsic_state &ext_state) const;
-  const svalue2 *get_origin (const svalue2 *sval,
+  const svalue *get_origin (const svalue *sval,
 			     const extrinsic_state &ext_state) const;
 
-  void set_state (region_model2 *model,
-		  const svalue2 *sval,
+  void set_state (region_model *model,
+		  const svalue *sval,
 		  state_machine::state_t state,
-		  const svalue2 *origin,
+		  const svalue *origin,
 		  const extrinsic_state &ext_state);
-  bool set_state (const equiv_class2 &ec,
+  bool set_state (const equiv_class &ec,
 		  state_machine::state_t state,
-		  const svalue2 *origin,
+		  const svalue *origin,
 		  const extrinsic_state &ext_state);
-  bool impl_set_state (const svalue2 *sval,
+  bool impl_set_state (const svalue *sval,
 		       state_machine::state_t state,
-		       const svalue2 *origin,
+		       const svalue *origin,
 		       const extrinsic_state &ext_state);
 
   void set_global_state (state_machine::state_t state);
@@ -143,25 +143,17 @@ public:
 
   void purge_for_unknown_fncall (const exploded_graph &eg,
 				 const gcall *call, tree fndecl,
-				 region_model2 *new_model,
-				 region_model2_context *ctxt);
+				 region_model *new_model,
+				 region_model_context *ctxt);
 
-  void on_svalue2_leak (const svalue2 *sval,
-			impl_region_model2_context *ctxt);
-  void on_liveness_change (const hash_set<const svalue2 *> &live_svalues,
-			   const region_model2 *model,
-			   impl_region_model2_context *ctxt);
-
-#if 0
-  void on_inherited_svalue (svalue_id parent_sid,
-			    svalue_id child_sid);
-
-  void on_cast (svalue_id src_sid,
-		svalue_id dst_sid);
-#endif
+  void on_svalue_leak (const svalue *sval,
+			impl_region_model_context *ctxt);
+  void on_liveness_change (const hash_set<const svalue *> &live_svalues,
+			   const region_model *model,
+			   impl_region_model_context *ctxt);
 
   void on_unknown_change (const state_machine &sm,
-			  const svalue2 *sval,
+			  const svalue *sval,
 			  bool is_mutable,
 			  const extrinsic_state &ext_state);
 
@@ -171,8 +163,8 @@ public:
   iterator_t begin () const { return m_map.begin (); }
   iterator_t end () const { return m_map.end (); }
 
-  static const svalue2 *
-  canonicalize_svalue2 (const svalue2 *sval, const extrinsic_state &ext_state);
+  static const svalue *
+  canonicalize_svalue (const svalue *sval, const extrinsic_state &ext_state);
 
 private:
   const state_machine &m_sm;
@@ -236,16 +228,16 @@ public:
 				 const program_point &point,
 				 const exploded_node *enode_for_diag) const;
 
-  tree get_representative_tree2 (const svalue2 *sval) const;
+  tree get_representative_tree (const svalue *sval) const;
 
-  bool can_purge_p2 (const extrinsic_state &ext_state,
-		     const svalue2 *sval)
+  bool can_purge_p (const extrinsic_state &ext_state,
+		     const svalue *sval)
   {
     /* Don't purge vars that have non-purgeable sm state, to avoid
        generating false "leak" complaints.  */
     int i;
-    sm_state_map2 *smap;
-    FOR_EACH_VEC_ELT (m_checker_states2, i, smap)
+    sm_state_map *smap;
+    FOR_EACH_VEC_ELT (m_checker_states, i, smap)
       {
 	const state_machine &sm = ext_state.get_sm (i);
 	if (!sm.can_purge_p (smap->get_state (sval, ext_state)))
@@ -255,25 +247,21 @@ public:
   }
 
   bool can_merge_with_p (const program_state &other,
-			 const extrinsic_state &ext_state,
-			 const program_point &point,
-			 program_state *out) const;
-  bool can_merge_with2_p (const program_state &other,
 			  const extrinsic_state &ext_state,
 			  const program_point &point,
 			  program_state *out) const;
 
   void validate (const extrinsic_state &ext_state) const;
 
-  static void detect_leaks2 (const program_state &src_state,
-			     const program_state &dest_state,
-			     const svalue2 *extra_sval,
-			     const extrinsic_state &ext_state,
-			     region_model2_context *ctxt);
+  static void detect_leaks (const program_state &src_state,
+			    const program_state &dest_state,
+			    const svalue *extra_sval,
+			    const extrinsic_state &ext_state,
+			    region_model_context *ctxt);
 
   /* TODO: lose the pointer here (const-correctness issues?).  */
-  region_model2 *m_region_model2;
-  auto_delete_vec<sm_state_map2> m_checker_states2;
+  region_model *m_region_model;
+  auto_delete_vec<sm_state_map> m_checker_states;
 
   /* If false, then don't attempt to explore further states along this path.
      For use in "handling" lvalues for tree codes we haven't yet
@@ -281,12 +269,12 @@ public:
   bool m_valid;
 };
 
-/* An abstract base class for use with for_each_state_change2.  */
+/* An abstract base class for use with for_each_state_change.  */
 
-class state_change_visitor2
+class state_change_visitor
 {
 public:
-  virtual ~state_change_visitor2 () {}
+  virtual ~state_change_visitor () {}
 
   /* Return true for early exit, false to keep iterating.  */
   virtual bool on_global_state_change (const state_machine &sm,
@@ -297,14 +285,14 @@ public:
   virtual bool on_state_change (const state_machine &sm,
 				state_machine::state_t src_sm_val,
 				state_machine::state_t dst_sm_val,
-				const svalue2 *dst_sval,
-				const svalue2 *dst_origin_sval) = 0;
+				const svalue *dst_sval,
+				const svalue *dst_origin_sval) = 0;
 };
 
-extern bool for_each_state_change2 (const program_state &src_state,
+extern bool for_each_state_change (const program_state &src_state,
 				    const program_state &dst_state,
 				    const extrinsic_state &ext_state,
-				    state_change_visitor2 *visitor);
+				    state_change_visitor *visitor);
 
 /* A class for recording "interesting" state changes.
    This is used for annotating edges in the GraphViz output of the
@@ -333,9 +321,6 @@ class state_change
 
     void dump (pretty_printer *pp, const extrinsic_state &ext_state) const;
 
-    void remap_svalue_ids (const svalue_id_map &map);
-    int on_svalue_purge (svalue_id first_unused_sid);
-
     void validate (const program_state &new_state,
 		   const extrinsic_state &ext_state) const;
 
@@ -358,9 +343,6 @@ class state_change
   void dump (pretty_printer *pp, const extrinsic_state &ext_state) const;
   void dump (const extrinsic_state &ext_state) const;
 
-  void remap_svalue_ids (const svalue_id_map &map);
-  int on_svalue_purge (svalue_id first_unused_sid);
-
   void validate (const program_state &new_state,
 		 const extrinsic_state &ext_state) const;
 
